bool Fresh_Start = true;
unsigned long Led1Blink, Led2Blink, Led3Blink;
int ScreenPrevious = -1;
int ScreenNew = 0;
unsigned long ProgRunTime, OldRunTime;
unsigned long ProgFixTime, OldFixTime;
unsigned int Running_Seconds, Running_Minutes, Running_Hours, Running_Days;
unsigned int Fix_Seconds, Fix_Minutes, Fix_Hours, Fix_Days;
int NewFixMode = 0, OldFixMode = -1;
int NewSatsInView = 0, OldSatsInView = -1;
int NewSatsInUse = 0, OldSatsInUse = -1;
int GpsTimeSecondNew = 0, GpsTimeMinuteNew = 0, GpsTimeHourNew = 0;
int LocalTimeSecondNew = 0, LocalTimeMinuteNew = 0, LocalTimeHourNew = 0;
int GpsTimeSecondOld = -1, GpsTimeMinuteOld = -1, GpsTimeHourOld = -1;
int LocalTimeSecondOld = 0, LocalTimeMinuteOld = 0, LocalTimeHourOld = 0;
int GpsDateDayNew = 0, GpsDateMonthNew = 0, GpsDateYearNew = 0;
int LocalDateDayNew = 0, LocalDateMonthNew = 0, LocalDateYearNew = 0;
int GpsDateDayOld = -1, GpsDateMonthOld = -1, GpsDateYearOld = -1;
int LocalDateDayOld = -1, LocalDateMonthOld = -1, LocalDateYearOld = -1;
byte EncoderRotate, EncoderPush;
char SATS_IN_USE[] = " 0/";
char SATS_IN_VIEW[] = " 0";
char PROG_RUN_TIME[]= "   0  0:00:00", OLD_RUN_TIME[]= "   0  0:00:00";
char PROG_FIX_TIME[]= "   0  0:00:00", OLD_FIX_TIME[]= "   0  0:00:00";
char NEW_UTC_TIME[] = " 0: 0: 0", OLD_UTC_TIME[] = " 0: 0: 0";
char NEW_UTC_DATE[] = " 0/ 0/   0", OLD_UTC_DATE[] = " 0/ 0/   0";
char NEW_LAT[] = "000.000000", OLD_LAT[] = "000.000000";
char NEW_LAT_IND[] = " ", OLD_LAT_IND[] = " ";
char NEW_LNG[] = "000.000000", OLD_LNG[] = "000.000000";
char NEW_LNG_IND[] = " ", OLD_LNG_IND[] = " ";
char NEW_LOCATOR[] = "      ", OLD_LOCATOR[] = "      ";
double Lattitude, Longitude;
bool LatUpdate = false, LngUpdate = false;
char EmptyLine[] = "                    ";

void LcdWipeClean()
{
 #ifdef LCD_2004
   lcd.setCursor(0,0);
   lcd.print(EmptyLine);
   lcd.print(EmptyLine);
   lcd.print(EmptyLine);
   lcd.print(EmptyLine);
 #endif 
}

void LedSwitch (int Ledpin, int Ledmode, int Ledstatus) {
  pinMode (Ledpin, OUTPUT);  // Set the output mode for the led to control
  if (Ledmode == SINGLEL){
    if (Ledstatus == SINGLE_OFF) digitalWrite (Ledpin, HIGH); else digitalWrite (Ledpin, LOW);  // Pin is Sinking Low for Led on
  }
  else if (Ledmode == SINGLEH){
    if (Ledstatus == SINGLE_OFF) digitalWrite (Ledpin, LOW); else digitalWrite (Ledpin, HIGH);  // Pin is sourcing High for Led on  
  }
  else if (Ledmode == 2){
    // Here should be the code for bicolor Led's
  }
}

// given a Timezone object, UTC and a string description, convert and print local time with time zone
void printDateTime(Timezone tz, time_t utc, const char *descr)
{
    char buf[40];
    char m[4];    // temporary storage for month string (DateStrings.cpp uses shared buffer)
    TimeChangeRule *tcr;        // pointer to the time change rule, use to get the TZ abbrev

    time_t t = tz.toLocal(utc, &tcr);
    strcpy(m, monthShortStr(month(t)));
    sprintf(buf, "%.2d:%.2d:%.2d %s %.2d %s %d %s",
        hour(t), minute(t), second(t), dayShortStr(weekday(t)), day(t), m, year(t), tcr -> abbrev);
    Serial.print(buf);
    Serial.print(' ');
    Serial.println(descr);
}

void DisplayLocator()
{
  if (strcmp(NEW_LOCATOR,OLD_LOCATOR)!=0) {
    strncpy(OLD_LOCATOR, NEW_LOCATOR, 6);
    #ifdef LCD_2004
      lcd.setCursor(7,3);
      lcd.print(NEW_LOCATOR);
    #endif 
  }
}

void calcLocator(char *dst, double lat, double lon) {
  int o1, o2, o3;
  int a1, a2, a3;
  double remainder;
  // longitude
  remainder = lon + 180.0;
  o1 = (int)(remainder / 20.0);
  remainder = remainder - (double)o1 * 20.0;
  o2 = (int)(remainder / 2.0);
  remainder = remainder - 2.0 * (double)o2;
  o3 = (int)(12.0 * remainder);

  // latitude
  remainder = lat + 90.0;
  a1 = (int)(remainder / 10.0);
  remainder = remainder - (double)a1 * 10.0;
  a2 = (int)(remainder);
  remainder = remainder - (double)a2;
  a3 = (int)(24.0 * remainder);
  dst[0] = (char)o1 + 'A';
  dst[1] = (char)a1 + 'A';
  dst[2] = (char)o2 + '0';
  dst[3] = (char)a2 + '0';
  dst[4] = (char)o3 + 'a';
  dst[5] = (char)a3 + 'a';
  dst[6] = (char)0;
}

void UpdateLongitude()
{
  float RawLng = gps.location.lng();
  Longitude = RawLng;
  dtostrf(abs(RawLng),10, 6, NEW_LNG);
  if (strcmp(NEW_LNG,OLD_LNG)!=0) {
    dtostrf(RawLng,10, 6, OLD_LNG);
    #ifdef LCD_2004
      lcd.setCursor(7,2);
      lcd.print(NEW_LNG);
      LngUpdate = true;
    #endif 
    if (RawLng >= 0)NEW_LNG_IND[0] = char(69); else NEW_LNG_IND[0] = char(87);
    if (strcmp(NEW_LNG_IND,OLD_LNG_IND)!=0) {
      if (RawLng >= 0)OLD_LNG_IND[0] = char(69); else OLD_LNG_IND[0] = char(87);
       #ifdef LCD_2004
         lcd.setCursor(5,2);
         lcd.print(NEW_LNG_IND[0]);
       #endif  
    }  
  }
}    

void UpdateLattitude()
{
  float RawLat = gps.location.lat();
  Lattitude = RawLat;
  dtostrf(abs(RawLat),10, 6, NEW_LAT);
  if (strcmp(NEW_LAT,OLD_LAT)!=0) {
    dtostrf(RawLat,10, 6, OLD_LAT);
    #ifdef LCD_2004
      lcd.setCursor(7,1);
      lcd.print(NEW_LAT);
      LatUpdate = true;
    #endif  
    if (RawLat >= 0)NEW_LAT_IND[0] = char(78); else NEW_LAT_IND[0] = char(83);
    if (strcmp(NEW_LAT_IND,OLD_LAT_IND)!=0) {
      if (RawLat >= 0)OLD_LAT_IND[0] = char(78); else OLD_LAT_IND[0] = char(83);
        #ifdef LCD_2004
          lcd.setCursor(5,1);
          lcd.print(NEW_LAT_IND[0]);
        #endif  
     }   
   }    
}  

void UpdateUtcTime()
{
  char Hours[]= " 0", Minutes[] = ":00", Seconds[]= ":00";
  GpsTimeHourNew=gps.time.hour();
  GpsTimeMinuteNew=gps.time.minute();
  GpsTimeSecondNew=gps.time.second();
  if (GpsTimeHourNew!=GpsTimeHourOld) {
    GpsTimeHourOld = GpsTimeHourNew;
    if (ScreenNew == 0){
      sprintf(Hours,"%2d",GpsTimeHourNew);
      #ifdef LCD_2004
        lcd.setCursor(5, 1);
        lcd.print(Hours);
      #endif  
    }
  }
  if (GpsTimeMinuteNew!=GpsTimeMinuteOld) {
    GpsTimeMinuteOld = GpsTimeMinuteNew;
    if (ScreenNew == 0){
      sprintf(Minutes,":%02d",GpsTimeMinuteNew);
      #ifdef LCD_2004
        lcd.setCursor(7, 1);
        lcd.print(Minutes);
      #endif  
    }
  }
  if (GpsTimeSecondNew!=GpsTimeSecondOld) {
    GpsTimeSecondOld = GpsTimeSecondNew;
    Led2Stat = SINGLE_ON; 
    LedSwitch (Led2,Led2Mode,SINGLE_ON);  // New GPS time. second led on as timpepulse
    Led2Blink = millis();
    if (ScreenNew == 0){
      sprintf(Seconds,":%02d",GpsTimeSecondNew);
      #ifdef LCD_2004
        lcd.setCursor(10, 1);
        lcd.print(Seconds);
      #endif  
    }
  }
}

void UpdateLocalTime(){
  char Hours[]= " 0", Minutes[] = ":00", Seconds[]= ":00";
  setTime(GpsTimeHourNew, GpsTimeMinuteNew, GpsTimeSecondNew, GpsDateDayNew, GpsDateMonthNew, GpsDateYearNew);        //another way to set the time (hr,min,sec,day,mnth,yr)
  time_t utc = now();
  time_t local = CE.toLocal(utc, &tcr);
  LocalTimeHourNew = hour(local);
  LocalTimeMinuteNew = minute(local);
  LocalTimeSecondNew = second(local);
  if (LocalTimeHourNew!=LocalTimeHourOld) {
    LocalTimeHourOld = LocalTimeHourNew;
    sprintf(Hours,"%2d",LocalTimeHourNew);
    #ifdef LCD_2004
      lcd.setCursor(7, 1);
      lcd.print(Hours);
    #endif  
  }
  if (LocalTimeMinuteNew!=LocalTimeMinuteOld) {
    LocalTimeMinuteOld = LocalTimeMinuteNew;
    sprintf(Minutes,":%02d",LocalTimeMinuteNew);
    #ifdef LCD_2004
      lcd.setCursor(9, 1);
      lcd.print(Minutes);
    #endif  
  }
  if (LocalTimeSecondNew!=LocalTimeSecondOld) {
    LocalTimeSecondOld = LocalTimeSecondNew;
    sprintf(Seconds,":%02d",LocalTimeSecondNew);
    #ifdef LCD_2004
      lcd.setCursor(12, 1);
        lcd.print(Seconds);
        lcd.print(" ");
        lcd.print(tcr -> abbrev);
      #endif  
  }
}

void UpdateUtcDate(){
  char Date[]= " 0", Month[] = "/ 0", Year[]= "/0000";
  GpsDateDayNew=gps.date.day();
  GpsDateMonthNew=gps.date.month();
  GpsDateYearNew=gps.date.year();
  if (GpsDateDayNew!=GpsDateDayOld) {
    GpsDateDayOld = GpsDateDayNew;
    if (ScreenNew == 0){
      sprintf(Date,"%2d",GpsDateDayNew);
      #ifdef LCD_2004
        lcd.setCursor(5, 2);
        lcd.print(Date);
    #endif  
    }
  }
  if (GpsDateMonthNew!=GpsDateMonthOld) {
    GpsDateMonthOld = GpsDateMonthNew;
    sprintf(Month,"/%2d",GpsDateMonthNew);
    if (ScreenNew == 0){
      #ifdef LCD_2004
        lcd.setCursor(7, 2);
        lcd.print(Month);
      #endif  
    }
  }
  if (GpsDateYearNew!=GpsDateYearOld) {
    GpsDateYearOld = GpsDateYearNew;
    sprintf(Year,"/%4d",GpsDateYearNew);
    if (ScreenNew == 0){
      #ifdef LCD_2004
        lcd.setCursor(10, 2);
        lcd.print(Year);
      #endif  
    }
  }
}

void UpdateLocalDate(){
  char Date[]= " 0", Month[] = "/ 0", Year[]= "/0000";
  time_t utc = now();
  time_t local = CE.toLocal(utc, &tcr);
  LocalDateDayNew = day(local);
  LocalDateMonthNew = month(local);
  LocalDateYearNew = year(local);
  if (LocalDateDayNew!=LocalDateDayOld) {
    LocalDateDayOld = LocalDateDayNew;
    sprintf(Date,"%2d",LocalDateDayNew);
    #ifdef LCD_2004
      lcd.setCursor(7, 2);
      lcd.print(Date);
    #endif  
  }
  if (LocalDateMonthNew!=LocalDateMonthOld) {
    LocalDateMonthOld = LocalDateMonthNew;
    sprintf(Month,"/%2d",LocalDateMonthNew);
    #ifdef LCD_2004
      lcd.setCursor(9, 2);
      lcd.print(Month);
    #endif  
  }
  if (LocalDateYearNew!=LocalDateYearOld) {
    LocalDateYearOld = LocalDateYearNew;
    sprintf(Year,"/%4d",LocalDateYearNew);
    #ifdef LCD_2004
      lcd.setCursor(12, 2);
      lcd.print(Year);
    #endif  
  }
}

void UpdateSatsInUse ()
{
  NewSatsInUse = String(satsInUse.value()).toInt();
  if (NewSatsInUse != OldSatsInUse){
    sprintf(SATS_IN_USE, "%2d/",NewSatsInUse);      
    OldSatsInUse = NewSatsInUse;
    #ifdef LCD_2004
      lcd.setCursor(15, 0);
      lcd.print(SATS_IN_USE);
    #endif  
  }
}

void UpdateSatsInView ()
{
  NewSatsInView = String(satsInView.value()).toInt();
  if (NewSatsInView != OldSatsInView){
    sprintf(SATS_IN_VIEW, "%2d",NewSatsInView);      
    OldSatsInView = NewSatsInView;
    #ifdef LCD_2004
      lcd.setCursor(18, 0);
      lcd.print(SATS_IN_VIEW);
    #endif  
  }
}

void UpdateSatFixMode()
{
  NewFixMode = String(satFixMode.value()).toInt();
  if (NewFixMode != OldFixMode){
    OldFixMode = NewFixMode;
    if (ScreenNew <= 3){
      #ifdef LCD_2004
        lcd.setCursor(0, 0);
      #endif  
      if (NewFixMode <= 1){
        #ifdef LCD_2004
          lcd.print(MSG_GPS_UNLOCK);
        #endif
        Fix_Days = 0;
        Fix_Hours = 0;
        Fix_Minutes = 0;
        Fix_Seconds = 0; 
        ProgFixTime = 0;
        OldFixTime = 0;
        sprintf(PROG_FIX_TIME, "%4d %2d:%02d:%02d",Fix_Days,Fix_Hours,Fix_Minutes,Fix_Seconds);
        sprintf(OLD_FIX_TIME, "%4d %2d:%02d:%02d",Fix_Days,Fix_Hours,Fix_Minutes,Fix_Seconds);
        if (ScreenNew == 3){
          #ifdef LCD_2004
            lcd.setCursor(5, 2);
            lcd.print(PROG_FIX_TIME);
          #endif  
        }
      }
      if (NewFixMode == 2){
        #ifdef LCD_2004
          lcd.print(MSG_GPS_LOCK_2D); 
        #endif
      }
      if (NewFixMode == 3){
        #ifdef LCD_2004
          lcd.print(MSG_GPS_LOCK_3D); 
        #endif
      }
    }
  }
}

void   UpdateFixTime ()
{
  if (NewFixMode > 1){
    ProgFixTime += (millis() - OldFixTime);
    OldFixTime = millis();
    if (ProgFixTime >= 1000) {
      ProgFixTime -= 1000;
      Fix_Seconds += 1;
      if (Fix_Seconds >=60) {
        Fix_Seconds -= 60;
        Fix_Minutes += 1;    
      }
      if (Fix_Minutes >=60) {
        Fix_Minutes -= 60;
        Fix_Hours += 1;    
      }
      if (Fix_Hours >=24) {
        Fix_Hours -= 24;
        Fix_Days += 1;    
      }
      sprintf(PROG_FIX_TIME, "%4d %2d:%02d:%02d",Fix_Days,Fix_Hours,Fix_Minutes,Fix_Seconds);
    }
    if (strcmp(PROG_FIX_TIME,OLD_FIX_TIME)!=0) {
      sprintf(OLD_FIX_TIME, "%4d %2d:%02d:%02d",Fix_Days,Fix_Hours,Fix_Minutes,Fix_Seconds);
      if (ScreenNew == 3){
        #ifdef LCD_2004
          lcd.setCursor(5,2);
          lcd.print(PROG_FIX_TIME);
        #endif  
      }  
    }
  }
  else {
    OldFixTime = millis();
  }
}

void   UpdateRunningTime ()
{
  unsigned int Running;
  ProgRunTime += (millis() - OldRunTime);
  OldRunTime = millis();
  if (ProgRunTime >= 1000) {
    ProgRunTime -= 1000;
    Running_Seconds += 1;
    if (Running_Seconds >=60) {
      Running_Seconds -= 60;
      Running_Minutes += 1;    
    }
    if (Running_Minutes >=60) {
      Running_Minutes -= 60;
      Running_Hours += 1;    
    }
    if (Running_Hours >=24) {
      Running_Hours -= 24;
      Running_Days += 1;    
    }
    sprintf(PROG_RUN_TIME, "%4d %2d:%02d:%02d",Running_Days,Running_Hours,Running_Minutes,Running_Seconds);
  }
  if (strcmp(PROG_RUN_TIME,OLD_RUN_TIME)!=0) {
    sprintf(OLD_RUN_TIME, "%4d %2d:%02d:%02d",Running_Days,Running_Hours,Running_Minutes,Running_Seconds);
    if (ScreenNew == 3){
      #ifdef LCD_2004
        lcd.setCursor(5,1);
        lcd.print(PROG_RUN_TIME);
      #endif  
    }  
  }
}

void BuildScreen0 ()
{
  #ifdef LCD_2004
    LcdWipeClean();
    lcd.setCursor(0, 1);
    lcd.print(MSG_TIME_UTC);
  #endif
  OldSatsInUse = -1;
  OldSatsInView = -1;
  OldFixMode = -1;
  GpsTimeHourOld = -1;
  GpsTimeMinuteOld = -1;
  GpsTimeSecondOld = -1;
  GpsDateDayOld = -1;
  GpsDateMonthOld = -1;
  GpsDateYearOld = -1;
}

void BuildScreen1 ()
{
  #ifdef LCD_2004
    LcdWipeClean();
    lcd.setCursor(0, 1);
    lcd.print(MSG_TIME_LOCAL);
  #endif
  OldSatsInUse = -1;
  OldSatsInView = -1;
  OldFixMode = -1;
  LocalTimeHourOld = -1;
  LocalTimeMinuteOld = -1;
  LocalTimeSecondOld = -1;
  LocalDateDayOld = -1;
  LocalDateMonthOld = -1;
  LocalDateYearOld = -1;
}

void BuildScreen2 ()
{
  #ifdef LCD_2004
    LcdWipeClean();
    lcd.setCursor(0, 1);
    lcd.print(MSG_GPS_LAT);
    lcd.setCursor(0, 2);
    lcd.print(MSG_GPS_LON);
    lcd.setCursor(0, 3);
    lcd.print(MSG_LOCATOR);
  #endif
  OldSatsInUse = -1;
  OldSatsInView = -1;
  OldFixMode = -1;
  strncpy(OLD_LAT, "000.000000", 10);
  OLD_LAT_IND[0] = char(32);
  strncpy(OLD_LNG, "000.000000", 10);
  OLD_LNG_IND[0] = char(32);
  strncpy(OLD_LOCATOR, "      ", 6);
  LatUpdate = true;
  LngUpdate = true;
}


void BuildScreen3 ()
{
  #ifdef LCD_2004
    LcdWipeClean();
    lcd.setCursor(0, 1);
    lcd.print(MSG_PROG_RUN);
    lcd.setCursor(0, 2);
    lcd.print(MSG_GPS_FIX);
  #endif
  OldSatsInUse = -1;
  OldSatsInView = -1;
  OldFixMode = -1;
}

void BuildScreen4 ()
{
  #ifdef LCD_2004
    LcdWipeClean();
    lcd.setCursor(0, 0);
    lcd.print(MSG_HARDWARE_OPTION);
    lcd.setCursor(0,1);
    lcd.print(MSG_HARDWARE_RS232C);
    if (RS232chip == 1) lcd.print(MSG_ON); else lcd.print(MSG_OFF);
    lcd.setCursor(0,2);
    lcd.print(MSG_HARDWARE_SI5351);
    if (Si5351chip == 1) lcd.print(MSG_ON); else lcd.print(MSG_OFF);
    // Option not yet implemented
    //lcd.setCursor(0,3);
    //lcd.print(MSG_HARDWARE_ADF4351);
    //if (Adf4351chip == 1) lcd.print(MSG_ON); else lcd.print(MSG_OFF);
  #endif
}

void BuildScreen5 ()
{
  #ifdef LCD_2004
    LcdWipeClean();
    lcd.setCursor(0, 0);
    lcd.print(MSG_USB_NMEA);
    lcd.setCursor(12,0);
    if (NmeaUSBOn == 1) lcd.print(MSG_ON); else lcd.print(MSG_OFF);
    lcd.setCursor(1,1);
    lcd.print(MSG_BAUD_RATE);
    lcd.setCursor(12,1);
    if (NmeaUSBBaud == 9600) lcd.print(MSG_BAUD_9600);
    if (NmeaUSBBaud == 19200) lcd.print(MSG_BAUD_19200);
    if (NmeaUSBBaud == 38400) lcd.print(MSG_BAUD_38400);
    if (NmeaUSBBaud == 57600) lcd.print(MSG_BAUD_57600);
    if (NmeaUSBBaud == 115200) lcd.print(MSG_BAUD_115200);  
  #endif  

  if (RS232chip == 1) {
    #ifdef LCD_2004
      lcd.setCursor(0, 2);
      lcd.print(MSG_RS232C_NMEA);
      lcd.setCursor(12,2);
      if (NmeaRS232On == 1) lcd.print(MSG_ON); else lcd.print(MSG_OFF);
      lcd.setCursor(1,3);
      lcd.print(MSG_BAUD_RATE);
      lcd.setCursor(12,3);
      if (NmeaRS232Baud == 9600) lcd.print(MSG_BAUD_9600);
      if (NmeaRS232Baud == 19200) lcd.print(MSG_BAUD_19200);
      if (NmeaRS232Baud == 38400) lcd.print(MSG_BAUD_38400);
      if (NmeaRS232Baud == 57600) lcd.print(MSG_BAUD_57600);
      if (NmeaRS232Baud == 115200) lcd.print(MSG_BAUD_115200);  
    #endif
  }
}

void BuildScreen6 ()
{
  sprintf(NEW_SI_0_HERTZ,"%3d.%03d.%03d,%02d",Si0MHertz,Si0kHertz,Si0Hertz,Si0mHertz);
  #ifdef LCD_2004
    LcdWipeClean();
    lcd.setCursor(0, 0);
    lcd.print(MSG_SI_CLK0);
    lcd.setCursor(0, 1);
    lcd.print(MSG_OUTPUT);
    if (Si0Level == 0) lcd.print(MSG_OFF); 
    else if (Si0Level == 1) lcd.print(MSG_LOW);
    else if (Si0Level == 2) lcd.print(MSG_HIGH);
    lcd.setCursor(0, 2);
    lcd.print(NEW_SI_0_HERTZ);
    lcd.print(MSG_HERZ);
 #endif  
}

void BuildScreen7 ()
{
  sprintf(NEW_SI_1_HERTZ,"%3d.%03d.%03d,%02d",Si1MHertz,Si1kHertz,Si1Hertz,Si1mHertz);
  #ifdef LCD_2004
    LcdWipeClean();
    lcd.setCursor(0, 0);
    lcd.print(MSG_SI_CLK1);
    lcd.setCursor(0, 1);
    lcd.print(MSG_OUTPUT);
    if (Si1Level == 0) lcd.print(MSG_OFF); 
    else if (Si1Level == 1) lcd.print(MSG_LOW);
    else if (Si1Level == 2) lcd.print(MSG_HIGH);
    lcd.setCursor(0, 2);
    lcd.print(NEW_SI_1_HERTZ);
    lcd.print(MSG_HERZ);
  #endif  
}

void BuildScreen8 ()
{
  sprintf(NEW_SI_2_HERTZ,"%3d.%03d.%03d,%02d",Si2MHertz,Si2kHertz,Si2Hertz,Si2mHertz);
  #ifdef LCD_2004
    LcdWipeClean();
    lcd.setCursor(0, 0);
    lcd.print(MSG_SI_CLK2);
    lcd.setCursor(0, 1);
    lcd.print(MSG_OUTPUT);
    if (Si2Level == 0) lcd.print(MSG_OFF); 
    else if (Si2Level == 1) lcd.print(MSG_LOW);
    else if (Si2Level == 2) lcd.print(MSG_HIGH);
    lcd.setCursor(0, 2);
    lcd.print(NEW_SI_2_HERTZ);
    lcd.print(MSG_HERZ);
  #endif  
}

void BuildScreen9 ()
{
  sprintf(NEW_ADF_HERTZ,"%01d%03d.%03d.%03d",AdfGHz,AdfMHz,AdfkHz,AdfHz);
  #ifdef LCD_2004
    LcdWipeClean();
    lcd.setCursor(0, 0);
    lcd.print(MSG_ADF_CLK);
    lcd.setCursor(0, 1);
    lcd.print(MSG_OUTPUT);
    if (AdfLevel == 0) lcd.print(MSG_OFF); else lcd.print(AdfLevel);
    lcd.setCursor(0, 2);
    lcd.print(NEW_ADF_HERTZ);
    lcd.print(MSG_HERZ);
  #endif  
}

void ScreenState ()
{
  if (ScreenNew != ScreenPrevious) {
    ScreenPrevious = ScreenNew;
    switch (ScreenNew){
    case 0:
      BuildScreen0();
      break;
    case 1:
      BuildScreen1();
      break;
    case 2:
      BuildScreen2();
      break;
    case 3:
      BuildScreen3();
      break;
    case 4:
      BuildScreen4();
      break;
    case 5:
      BuildScreen5();
      break;
    case 6:
      BuildScreen6();
      break;
    case 7:
      BuildScreen7();
      break;
    case 8:
      BuildScreen8();
      break;
    case 9:
      BuildScreen9();
      break;
    }
  }
}


void GpsHardwareFail () {
  // Stop all serial communication
  Serial.end();
  Serial1.end();
  Serial3.end();
  #ifdef LCD_2004
    lcd.clear();
    lcd.setCursor(5, 1);
    lcd.print(MSG_GPS);
    lcd.setCursor(5, 2);
    lcd.print(MSG_FAIL);
  #endif  
  while (true) {
    // do nothing forever and blink first led as warning at 4 Hz.
    if (((millis()-Led1Blink)) >= 250) {
      Led1Blink = millis();
      if (Led1Stat == SINGLE_OFF) {
        Led1Stat = SINGLE_ON;
        LedSwitch (Led1,Led1Mode,Led1Stat);
      }
      else {
        Led1Stat = SINGLE_OFF;
        LedSwitch (Led1,Led1Mode,Led1Stat);
      }
    }
  }
}

void Start_Display_Welcome () {
  #ifdef LCD_2004
    lcd.init();                       // initialize the lcd
    lcd.backlight();                  // Lcd backlight on
    lcd.setCursor(3, 1);
    lcd.print(MSG_WELCOME);
    lcd.setCursor(2, 2);
    lcd.print(MSG_SETUP);
  #endif
}
//eof
